// SDK_SM301Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "SDK_SM301.h"
#include "SDK_SM301Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

///////// Include the DLL function declaration file ///////////////
#include "SPdbUSBIRCS_DLL.h"
///////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDK_SM301Dlg dialog

CSDK_SM301Dlg::CSDK_SM301Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSDK_SM301Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSDK_SM301Dlg)
	m_bTECooler = FALSE;
	m_lIntTime = 3;
	m_lTimeAve = 1;
	m_strIntTime = _T("");
	m_strStatus = _T("");
	m_strTECooler = _T("");
	m_strTestBd = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSDK_SM301Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSDK_SM301Dlg)
	DDX_Control(pDX, IDC_EDIT_TIMEAVE, m_editTimeAve);
	DDX_Control(pDX, IDC_EDIT_INTTIME, m_editIntTime);
	DDX_Control(pDX, IDCANCEL, m_btnClose);
	DDX_Control(pDX, IDC_COMBO_WELL, m_cbWell);
	DDX_Control(pDX, IDC_BTN_TESTBOARD, m_btnTestBd);
	DDX_Control(pDX, IDC_BTN_STORE, m_btnStore);
	DDX_Control(pDX, IDC_BTN_GETDATA, m_btnGetData);
	DDX_Control(pDX, IDC_BTN_BALANCE, m_btnBalance);
	DDX_Check(pDX, IDC_CHECK_TECOOLER, m_bTECooler);
	DDX_Text(pDX, IDC_EDIT_INTTIME, m_lIntTime);
	DDV_MinMaxLong(pDX, m_lIntTime, 3, 65535);
	DDX_Text(pDX, IDC_EDIT_TIMEAVE, m_lTimeAve);
	DDV_MinMaxLong(pDX, m_lTimeAve, 1, 1000);
	DDX_Text(pDX, IDC_STATIC_INTTIME, m_strIntTime);
	DDX_Text(pDX, IDC_STATIC_STATUS, m_strStatus);
	DDX_Text(pDX, IDC_STATIC_TECOOLER, m_strTECooler);
	DDX_Text(pDX, IDC_STATIC_TESTBOARD, m_strTestBd);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSDK_SM301Dlg, CDialog)
	//{{AFX_MSG_MAP(CSDK_SM301Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_TESTBOARD, OnBtnTestBoard)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_TECOOLER, OnCheckTECoolerOn)
	ON_EN_CHANGE(IDC_EDIT_INTTIME, OnChangeEditIntTime)
	ON_CBN_SELCHANGE(IDC_COMBO_WELL, OnSelchangeComboWell)
	ON_BN_CLICKED(IDC_BTN_BALANCE, OnBtnBalance)
	ON_BN_CLICKED(IDC_BTN_GETDATA, OnBtnGetData)
	ON_BN_CLICKED(IDC_BTN_STORE, OnBtnStore)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDK_SM301Dlg message handlers

BOOL CSDK_SM301Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//// Set Combo box controller ////
	m_cbWell.AddString("1pF");
	m_cbWell.AddString("4pF");
	m_cbWell.AddString("7pF");
	m_cbWell.AddString("10pF");
	// Charge Well Size combo box size setup
	CRect rt;
	m_cbWell.GetWindowRect(&rt);
	ScreenToClient(&rt);
	rt.bottom = rt.top + rt.Height()*3;
	m_cbWell.MoveWindow(rt);

	//// Disable Controllers first ////
	DisableCtrls();

	//// Initialize variables ////
	m_lArrayMode = 1;	// Cal Sensor PbS array detector. If the detector is from Sens Array, it should be "0".
	m_bIsConnected = false;
	m_bTECooler = TRUE;
	UpdateData(FALSE);
	//// Run Test Board ////
	OnBtnTestBoard();

	UpdateData(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSDK_SM301Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSDK_SM301Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSDK_SM301Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSDK_SM301Dlg::DisableCtrls()
{	// Disable controllers
	m_btnBalance.EnableWindow(FALSE);
	m_btnGetData.EnableWindow(FALSE);
	m_btnStore.EnableWindow(FALSE);
	m_cbWell.EnableWindow(FALSE);
	m_editTimeAve.EnableWindow(FALSE);
	m_editIntTime.EnableWindow(FALSE);

	m_strIntTime = "";
	m_strTECooler = "TE Cooler is Off...";
	m_strStatus = "";
}

void CSDK_SM301Dlg::OnBtnTestBoard() 
{	// Test Board
	long rtn;
	rtn = spTestBoard(&m_lIntTime, &m_lPxlNum, &m_lWell, m_lArrayMode);
	if(rtn == 1){	// No error on spTestBoard function
		m_bIsConnected = true;	// Now the board is connected.
		m_strTestBd = "The PbS array detector board is connected.";
		UpdateData(FALSE);
		// Activate some controllers //
		m_editIntTime.EnableWindow();	// Integration Time setting
		m_cbWell.EnableWindow();		// Charge Well Size setting
		m_cbWell.SetCurSel(m_lWell);	// Set Current Well size
		// Integration Time setting
		m_strIntTime.Format("X10/3 uSec = %.1f uSec", (double)m_lIntTime*10./3.);
		UpdateData(FALSE);
		OnCheckTECoolerOn();	// TE Cooler setting check
		m_btnBalance.EnableWindow();	// Balance Button activate
	}
	else{
		m_bIsConnected = false;	// Now the board is connected.
		m_strTestBd = "The PbS array detector board is NOT connected.";
		DisableCtrls();
	}
	
	UpdateData(FALSE);
}

void CSDK_SM301Dlg::OnClose() 
{	// Closed
	if(m_bIsConnected)
	{
		KillTimer(3);
		//// Close the PbS detector board handler. ////
		spCloseEx();
		///////////////////////////////////////////////
		m_bIsConnected = false;	// Now the board is disconnected.
	}

	CDialog::OnClose();
}

void CSDK_SM301Dlg::OnCancel() 
{	// the Close button is clicked
	if(m_bIsConnected)
	{
		KillTimer(3);
		//// Close the PbS detector board handler. ////
		spCloseEx();
		///////////////////////////////////////////////
		m_bIsConnected = false;	// Now the board is disconnected.
	}
	
	CDialog::OnCancel();
}

void CSDK_SM301Dlg::OnTimer(UINT nIDEvent) 
{
	CDialog::OnTimer(nIDEvent);

	// TODO: Add your message handler code here and/or call default
	long lTemp;
	long lTempMdf;

	//// Read TE Cooler temperature ////
	if(spReadTemp(&lTemp) != 1)
	{
		DisableCtrls();
		return;
	}
	lTempMdf = (long)(((2048. - (double)lTemp)/2048.) * 100.);
	// Set the temperature ratio from -100 to 100
	m_strTECooler.Format("TECooler Temp. Ratio, Cold(-100) - Hot(100) = %d", lTempMdf);
	UpdateData(FALSE);	
}

void CSDK_SM301Dlg::OnCheckTECoolerOn() 
{	// Check TE Cooler On/Off
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_bTECooler) 
	{	// if the TE cooler is On
		SetTimer(3, 500, NULL);
		//// Set TE Cooler ON ////
		if(spSetTECoolerEx((long)m_bTECooler) != 1)
		{
			KillTimer(3);
			DisableCtrls();
			return;
		}
	}
	else 	
	{	// if the TE Cooler is Off
		m_strTECooler.Format("TE Cooler is Off...");
		UpdateData(FALSE);
		KillTimer(3);	
		//// Set TE Cooler OFF ////
		if(spSetTECoolerEx((long)m_bTECooler) != 1)
		{
			KillTimer(3);
			DisableCtrls();
			return;
		}
	}
}

void CSDK_SM301Dlg::OnChangeEditIntTime() 
{	// Change in the integration time
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_lIntTime < 3)	m_lIntTime = 3;
	UpdateData(FALSE);

	m_strIntTime.Format("X10/3 uSec = %.1f uSec", (double)m_lIntTime*10./3.);
	UpdateData(FALSE);
}

void CSDK_SM301Dlg::OnSelchangeComboWell() 
{	// Select the Charge Well Size
	// TODO: Add your control notification handler code here
	long nId;
	
	UpdateData();
	nId = m_cbWell.GetCurSel();
	if(nId !=m_lWell)
	{
		m_lWell = (long)nId;

		m_btnGetData.EnableWindow(FALSE);
		m_btnStore.EnableWindow(FALSE);
	}
}

void CSDK_SM301Dlg::OnBtnBalance() 
{	// Run detector balancing
	// Array detector balancing... 
	// This should be run before getting data
	if(spBalanceEx((long)m_bTECooler, m_lWell) != 1)
	{
		DisableCtrls();
		KillTimer(3);
		return;
	}
	m_btnGetData.EnableWindow();	// Activate the Get Data button
	m_btnStore.EnableWindow();		// Actiavte the Store button
	m_editTimeAve.EnableWindow();	// Actiavte the Time averaging edit

	// Status setting
	m_strStatus = "The PbS detector is balanced.\n\r";
	m_strStatus += "Now you can get the data.\n\r";
	UpdateData(FALSE);
}

void CSDK_SM301Dlg::OnBtnGetData() 
{
	// TODO: Add your control notification handler code here
	int i, j;
	long *plArrayData, *plTempData;
	long lNumAve;

	UpdateData();

	//// Set Integration Time
	if(spSetIntTimeEx(m_lIntTime) != 1)
	{
		DisableCtrls();
		KillTimer(3);
		return;
	}

	// Memory Allocation
	plArrayData = new long[m_lPxlNum];
	plTempData = new long[m_lPxlNum];
	// Initialize variable
	lNumAve = 4;	// number of data samples to average prior to returning data to the calling procedure
					// Valid values are 1, 2, or 4 samples
	ZeroMemory(plTempData, m_lPxlNum*sizeof(long));	// Memory set as 0
	
	//// Get Data from the PbS array detector
	for(i=0 ; i<m_lTimeAve ; i++){	// Time avearging
		// Read data
		if(spReadDataEx(16, lNumAve, plArrayData) != 1){	// the first "16" means "16bit".
			delete[] plArrayData;
			delete[] plTempData;
			DisableCtrls();
			return;
		}
		for(j=0 ; j<m_lPxlNum ; j++)	plTempData[j] += plArrayData[j];
	}
	i = m_lPxlNum;
	for(j=0 ; j<m_lPxlNum ; j++){
		// The detector in the SM301 spectrometer is usually installed inversely.
		i--;
		plArrayData[i] = (long)((double)plTempData[j]/m_lTimeAve + 0.5);
	}
	delete[] plTempData;
	
	// Status setting
	m_strStatus += "The data reading was done successfully!\n\r";
	UpdateData(FALSE);

	//// Calibration data converion ////
	//// Spectrometer wavelength vs. pixel number Calibration Data set ////
	//// This set was given as an example.
	//// The customer has to use the proper calibration data set per each channel
	int nCalibNo=3 ;	// A number of the calibration data
	short nOrder = 2;	// The nOrder must be less than nCalibNo. If the nCalibNo is larger than 4, the best nOrder is "3". 
	float dWaveLength[3];
	float dPixelNo[3];
	float dRCoefficient[5];
	float dCoefficient[5];
	//Random calibration sample data (The customer has to use the calibration data set in the SM32Pro.ini file that SP provided along with the spectrometer) 
	dWaveLength[0] = 1318.0; dPixelNo[0] =  43;
	dWaveLength[1] = 1550.0; dPixelNo[1] =  72;
	dWaveLength[2] = 2636.0; dPixelNo[2] = 206;

	// Polynomial fitting
	spPolyFit(dPixelNo, dWaveLength, nCalibNo, dCoefficient, nOrder);
	spPolyFit(dWaveLength, dPixelNo, nCalibNo, dRCoefficient, nOrder);

	//// Save data ////
	CString strFile = "SDK_SM301.txt";
	CStdioFile sioFile;
	CString strSave;
	float dWL;

	// File Open
	sioFile.Open(strFile, CFile::modeCreate|CFile::modeWrite);

	// Save data
	strSave.Format(_T(" Pixel\t\tWavelength(nm)\tIntensity \r\n"));
	sioFile.WriteString(strSave);
	for(i=0 ; i<m_lPxlNum ; i++){
		// Polynomial fitting conversion
		spPolyCalc(dCoefficient, nOrder, (float)(i+1) ,&dWL);
		strSave.Format(_T(" %5d\t\t%5.2f\t\t%d\r\n"), i+1, dWL, plArrayData[i]);
		sioFile.WriteString(strSave);
	}
	sioFile.Close();
	delete[] plArrayData;

	// Status setting
	m_strStatus += "The data was saved as [SDK_SM301.txt] successfully!\n\r";
	UpdateData(FALSE);
}

void CSDK_SM301Dlg::OnBtnStore() 
{	// Stores all mux/detector array operational data & settings currently resident 
	// in the PIC processor's run-time memory to the PIC processor's NVRAM for future retrieval 
	// to a known operating state after a mux controller board power cycle.
	if(spStoreAllEx() != 1)	
	{
		DisableCtrls();
		KillTimer(3);
		return;
	}
	// Status setting
	m_strStatus += "The detector operational data and settings was saved in the NOVRAM successfully!";
	UpdateData(FALSE);
}
