// SPdbUSBIRCS_DLL.h : Spectral Products USB DLL function call

#ifndef __SPUSBIR_DLL_H__
#define __SPUSBIR_DLL_H__

#define DLLIMPORT extern "C" __declspec(dllimport)
#define	CALLTYPE	WINAPI

DLLIMPORT long CALLTYPE spTestBoard(long *lIntTime, long *lPxlNum, long *lCapWellInx, long lArryMode);
DLLIMPORT long CALLTYPE spSetTECoolerEx(long const lTECoolerOn);
DLLIMPORT long CALLTYPE spReadTemp(long *Temp);
DLLIMPORT long CALLTYPE spCloseEx();
DLLIMPORT long CALLTYPE spSetIntTimeEx(long const lIntegTime);
DLLIMPORT long CALLTYPE spBalanceEx(long const lTECoolerOn, long const lCapIndex);
DLLIMPORT long CALLTYPE spReadDataEx(long const lBit, long lNumAve, long *plPixArray);
DLLIMPORT long CALLTYPE spStoreAllEx();

DLLIMPORT void CALLTYPE spPolyCalc(float *coefs, short order, float x, float *y);
DLLIMPORT long CALLTYPE spPolyFit(float *x, float *y, short numPts, float *coefs, short order);

#endif