VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form vbSDK_USBIR 
   Caption         =   "Form1"
   ClientHeight    =   5715
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7260
   LinkTopic       =   "Form1"
   ScaleHeight     =   5715
   ScaleWidth      =   7260
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlgDialog 
      Left            =   0
      Top             =   4680
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   4680
      TabIndex        =   2
      Top             =   5040
      Width           =   975
   End
   Begin VB.CommandButton cmdGetData 
      Caption         =   "Get Data"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5880
      TabIndex        =   1
      Top             =   5040
      Width           =   1095
   End
   Begin VB.ListBox lstMessage 
      Height          =   4350
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   7335
   End
End
Attribute VB_Name = "vbSDK_USBIR"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' File Open/Save Dialog Flags
Const OFN_OVERWRITEPROMPT = &H2&
Const OFN_HIDEREADONLY = &H4&
Const OFN_FILEMUSTEXIST = &H1000&

' MsgBox parameters
Const MB_YESNO = 4
Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons
Const MB_ICONSTOP = 16          ' Critical message
Const MB_ICONQUESTION = 32      ' Warning query
Const MB_ICONEXCLAMATION = 48   ' Warning message
Const MB_ICONINFORMATION = 64   ' Information message

' MsgBox return values
Const IDOK = 1                  ' OK button pressed
Const IDCANCEL = 2              ' Cancel button pressed
Const IDABORT = 3               ' Abort button pressed
Const IDRETRY = 4               ' Retry button pressed
Const IDIGNORE = 5              ' Ignore button pressed
Const IDYES = 6                 ' Yes button pressed
Const IDNO = 7                  ' No button pressed
Const IDCONTINUE = 8            ' Continue button pressed

' Module variables
Dim gblCancel%   'True or False
Dim modFileName$, modFilePath$
Dim nPixelNo As Long
Dim fWL As Single
Dim fCoefficient(0 To 5) As Single

Dim SamArray(256) As Long

'The location of the SPdbUSBIR.dll should be specified exactly
'Or copy the SPdbUSBIR.dll to the C:\Windows\system

Private Declare Function spTestBoard Lib "SPdbUSBIRCS.dll" (ByRef lIntTime As Long, ByRef lPxlNum As Long, ByRef lCapWellInx As Long, ByVal lArryMode As Long) As Long
Private Declare Function spSetTECoolerEx Lib "SPdbUSBIRCS.dll" (ByVal lTECoolerOn As Long) As Long
Private Declare Function spReadTemp Lib "SPdbUSBIRCS.dll" (ByRef lTemp As Long) As Long
Private Declare Function spSetIntTimeEx Lib "SPdbUSBIRCS.dll" (ByVal lIntTime As Long) As Long
Private Declare Function spBalanceEx Lib "SPdbUSBIRCS.dll" (ByVal lTECoolerOn As Long, ByVal lCapWellInx As Long) As Long
Private Declare Function spReadDataEx Lib "SPdbUSBIRCS.dll" (ByVal lBit As Long, ByVal lNumAve As Long, MyPixArray As Long) As Long
Private Declare Function spStoreAllEx Lib "SPdbUSBIRCS.dll" () As Long
Private Declare Function spCloseEx Lib "SPdbUSBIRCS.dll" () As Long
Private Declare Function spPolyFit Lib "SPdbUSBIRCS.dll" (x As Single, y As Single, ByVal numPts As Integer, coefs As Single, ByVal order As Integer) As Long
Private Declare Sub spPolyCalc Lib "SPdbUSBIRCS.dll" (coefs As Single, ByVal order As Integer, ByVal x As Single, ByRef y As Single)


Private Sub cmdExit_Click()
    End
End Sub

Private Sub cmdGetData_Click()

  Dim bPixelFlip As Boolean
  
  
  Dim lRtn As Long
  Dim lIntTime As Long
  Dim lPxlNum As Long
  Dim lWell As Long
  Dim lArrayMode As Long
  Dim lTECoolerOn As Long
  Dim lBit As Long
  Dim lNumAve As Long
  Dim lTemp As Long
  
  Dim lTmp As Long
  
    lRtn = 0

    '////////////////////////////////////////// Board Test /////////////////////////////////////////////////
    lArrayMode = 1  'type of detector array. Cal Sensors' PbS/PbSe => 1, Sens Array's PbS/PbSe => 0
    ' SP's DLL function call: spTestBoard
    lRtn = spTestBoard(lIntTime, lPxlNum, lWell, lArrayMode)
                    'lIntTime: Integration time, the real integration time = lIntTime X 10 / 3 usec.
                    'lPxlNum: Total pixel number of the PbS/PbSe, currently 256
                    'lWell: Charge well size index. 0=1pF, 1=4pF, 2=7pF, 3=10pF
                    'Above three arguments will be retrieved from the detector board NVRAM
                    'lArrayMode: type of detector array. Cal Sensors' PbS/PbSe => 1, Sens Array's PbS/PbSe => 0
    If (lRtn < 0) Then
        lstMessage.AddItem "The board does not work correctly."
        lstMessage.Refresh
        Return
    Else
        lstMessage.AddItem "Testing the USB board... OK!"
        lstMessage.Refresh
    End If
    ' Total pixel number
    nPixelNo = lPxlNum
    '///////////////////////////////////////////////////////////////////////////////////////////////////////
    
    '///////////////////////////////////// Turn TE Cooler on ////////////////////////////////////////////////
    lTECoolerOn = 1 '1: TE Cooler on, 0: TE Cooler off
    ' SP's DLL function call: spSetTECoolerEx
    lRtn = spSetTECoolerEx(lTECoolerOn)
                        'lTECoolerOn: TE Cooler turning on/off indicator
                        '1: TE Cooler on, 0: TE Cooler off
    If (lRtn < 0) Then
        lstMessage.AddItem "There is an error on turning on the TE Cooler."
        lstMessage.Refresh
        Return
    Else
        lstMessage.AddItem "Turning on the TE Cooler... OK!"
        lstMessage.Refresh
    End If
    '///////////////////////////////////////////////////////////////////////////////////////////////////////
   
    '///////////////////////////////////// Read TE Cooler Temperature //////////////////////////////////////
    ' SP's DLL function call: spReadTemp
    Do
        DoEvents
        lRtn = spReadTemp(lTemp)
                        'lTemp: Current TE Cooler temperature indicator read from the TE Cooler board
                        'from 0 (cold) to 4096 (hot)
                        'After stablized, lTemp has to be ~2048.
        If (lRtn < 0) Then
            lstMessage.AddItem "There is an error on reading TE Cooler temperature."
            lstMessage.Refresh
            Return
        Else
            lTmp = (2048# - lTemp) / 2048# * 100#
            
            If (lTmp < 1) Then
                Exit Do
            End If
        End If
    Loop While (1)
    lstMessage.AddItem "The TE Cooler cooled down to ~0!"
    lstMessage.Refresh
    '///////////////////////////////////////////////////////////////////////////////////////////////////////
   
    '///////////////////////////////////// Set integration time ////////////////////////////////////////////
    lIntTime = 300  'The real integration time = lIntTime X 10 / 3 usec, lIntTime=300 => 1msec real integration time
    ' SP's DLL function call: spSetIntTimeEx
    lRtn = spSetIntTimeEx(lIntTime)
                        'lIntTime: integration time
                        'The real integration time = lIntTime X 10 / 3 usec
    If (lRtn < 0) Then
        lstMessage.AddItem "There is an error on setting the integration time."
        lstMessage.Refresh
        Return
    Else
        lstMessage.AddItem "Current integration time is 1msec."
        lstMessage.Refresh
    End If
    '///////////////////////////////////////////////////////////////////////////////////////////////////////
    lstMessage.AddItem "Initialize the board... OK!"
    lstMessage.Refresh
     
    lstMessage.AddItem "Start to balance the detector..."
    lstMessage.Refresh
    '///////////////////////////////////// Balancing the detector //////////////////////////////////////////
    MsgBox "Turn off or completely block the input light to balance the PbS/PbSe array detector", MB_ICONEXCLAMATION
    lWell = 1   'Capacitor Charge well size, 0=1pF, 1=4pF, 2=7pF, 3=10pF
    ' SP's DLL function call: spBalanceEx
    lRtn = spBalanceEx(lTECoolerOn, lWell)    'TE cooler on/off, Capacitor charge, detector balance
                        'lTECoolerOn: TE Cooler On/Off, On: 1, Off: 0
                        'lWell: Capacitor Charge well size, 0=1pF, 1=4pF, 2=7pF, 3=10pF
    If (lRtn < 0) Then
        lstMessage.AddItem "There is an error on balancing the detector."
        lstMessage.Refresh
        Return
    Else
        lstMessage.AddItem "Balancing the detector... OK!"
        lstMessage.Refresh
    End If
    '///////////////////////////////////////////////////////////////////////////////////////////////////////
    
    lstMessage.AddItem "Starting data acquisition..."
    lstMessage.Refresh
    '///////////////////////////////////// Data Acquisition ////////////////////////////////////////////////
    MsgBox "Ready to acquire data", MB_ICONEXCLAMATION
    lBit = 16   'Data converstion bit, 16: 16bit, i.e. 0-65535
    lNumAve = 4 'number of data samples to average prior to returning data to the calling procedure
                'Valid values are 1, 2, or 4 samples
    
    ' SP's DLL function call: spReadDataEx
    lRtn = spReadDataEx(lBit, lNumAve, SamArray(0))   ' Data acquisition
                    'lBit: data conversion bit, 16: 16bit, i.e. 0-65535
                    'lNumAve: number of data samples to average prior to returning data to the calling procedure
                    '         Valid values are 1, 2, or 4 samples
                    'SamArray:data array pointer, size = lPxlNum (256)
    If (lRtn < 0) Then
        MsgBox "Data Aquisition does not work correctly.", MB_ICONSTOP
        GoTo subEnd
    Else
        lstMessage.AddItem "Data acquisition has been finished successfully..."
        lstMessage.Refresh
    End If
    '///////////////////////////////////////////////////////////////////////////////////////////////////////
    
    '//////////////////////// Data Conversion, polynomial fitting and save /////////////////////////////////
    Dim x As Integer
    Dim y As Integer
    Dim k As Integer
    Dim fWaveLength(0 To 3) As Single
    Dim fPixelNo(0 To 3) As Single
    Dim CalibrationNo As Integer
    Dim nOrder As Integer
  
    bPixelFlip = True   'pixel data were reversed.
                        'Usually the PbS/PbSe array detector is installed in the SM301 reversely due to the location of the USB port & the power plug
    If bPixelFlip = True Then ' Data are reversed.
        For k = 0 To nPixelNo / 2
            x = k
            y = nPixelNo - k - 1
            lTmp = SamArray(x)
            SamArray(x) = SamArray(y)
            SamArray(y) = lTmp
        Next k
    End If
    'Calibration for the wavelength
    CalibrationNo = 3   'A number of the calibration data
    nOrder = 2          'The polynomial fitting order has to be less than the calibration data number
    'Random calibration sample data
    fWaveLength(0) = 1318#
    fPixelNo(0) = 43
    fWaveLength(1) = 1550#
    fPixelNo(1) = 72
    fWaveLength(2) = 2636#
    fPixelNo(2) = 206
    lRtn = spPolyFit(fPixelNo(0), fWaveLength(0), CalibrationNo, fCoefficient(0), nOrder)
'    lRtn = spPolyFit(fWaveLength(0), fPixelNo(0), CalibrationNo, fRCoefficient(0), nOrder)
    
    'Save data as a file
    SaveAsFile

    lstMessage.AddItem "Testing the PbS/PbSe detector and board has been completed successfully..."
    lstMessage.Refresh
    '///////////////////////////////////////////////////////////////////////////////////////////////////////

    '////////////////////////// Storing Operational data and settings //////////////////////////////////////
    ' SP's DLL function call: spStoreAllEx
    lRtn = spStoreAllEx()
    '///////////////////////////////////////////////////////////////////////////////////////////////////////

    '//////////////////////////////// Closing the device handler ///////////////////////////////////////////
    ' SP's DLL function call: spCloseEx
    lRtn = spCloseEx()
    '///////////////////////////////////////////////////////////////////////////////////////////////////////

subEnd:
End Sub

Private Sub cmdSave_Click()
    SaveAsFile
End Sub

Private Sub SaveAsFile()
  Dim Temp$, Temp1$, Temp2$, Temp3$, CR$, i%
      
  Dim rsp%, FileNumber%
  On Error GoTo SaveAsFileErr
  dlgDialog.InitDir = "*.txt"
    
  ' Flags: Sets the options for the Open and Save As dialog boxes.
  ' OFN_OVERWRITEPROMPT(&H2&): Causes the Save As dialog box to generate a message box if the
  ' selected file alreadyexits
  ' OFN_HIDEREADONLY (&H4&): Hides the Read Only checked box.
  dlgDialog.Flags = OFN_OVERWRITEPROMPT + OFN_HIDEREADONLY
  dlgDialog.CancelError = True
  ' Does the file exist?
  'dlgDialog.Filter = "Novram Files (*.NOV)|*.NOV|Text Files (*.TXT)|*.TXT|All Files (*.*)|*.*"
  dlgDialog.Filter = "Text Files (*.TXT)|*.TXT|All Files (*.*)|*.*"
  dlgDialog.Action = 2     ' 2: Save As
  modFileName = dlgDialog.FileTitle
  modFilePath = dlgDialog.FileName
  
  FileNumber% = FreeFile
  Dim k As Single
  Dim nOrder As Integer

  nOrder = 2          'The polynomial fitting order has to be less than the calibration data number
  
  Open modFilePath For Output As FileNumber%
  Temp$ = "Pixel" & "     " & "Wavelength(nm)" & "     " & "Intensity"
  Print #FileNumber%, Temp$
  For k = 0 To (nPixelNo - 1)    '32
    DoEvents
    Call spPolyCalc(fCoefficient(0), nOrder, (k + 1), fWL)
    Temp1$ = Format$(k + 1, "###0")
    Temp2$ = Format$(fWL, "###0.00")
    Temp3$ = Format$(SamArray(k), "###0.0000")
    Temp$ = Temp1$ & "             " & Temp2$ & "             " & Temp3$
    Print #FileNumber%, Temp$
  Next k
  Close FileNumber%
  ' MsgBox MessageInBox, TypeOfBox, TitleOfBox
  MsgBox modFilePath + " Saved", MB_ICONEXCLAMATION, "Save"


SaveAsFileResume:
  Exit Sub

SaveAsFileErr:
  Select Case Err
    Case 53
      MsgBox modFileName + Chr$(13) + "Cannot find this file" + Chr$(13) + "Please verify that the correct path and filename are given", 48
    Case 71
      rsp% = MsgBox("Disk not ready" + Chr$(13), MB_ICONEXCLAMATION + MB_RETRYCANCEL, "SaveAs: Error")
      If rsp% = IDRETRY Then
        Resume 0
      Else
        gblCancel% = True
      End If

    Case 32755
      ' "Cancel was selected"
      gblCancel% = True
    Case Else
      MsgBox "Error code is : " & Err, 48
  End Select
  Resume SaveAsFileResume

End Sub

Private Sub Form_Load()
    nPixelNo = 256 'for PbS/PbSe Detector
    
End Sub
