// SDK_SM301Dlg.h : header file
//

#if !defined(AFX_SDK_SM301DLG_H__7E2FDAE4_19B8_4DA9_B4C6_0B20AE981294__INCLUDED_)
#define AFX_SDK_SM301DLG_H__7E2FDAE4_19B8_4DA9_B4C6_0B20AE981294__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CSDK_SM301Dlg dialog

class CSDK_SM301Dlg : public CDialog
{
// Construction
public:
	CSDK_SM301Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSDK_SM301Dlg)
	enum { IDD = IDD_SDK_SM301_DIALOG };
	CEdit	m_editTimeAve;
	CEdit	m_editIntTime;
	CButton	m_btnClose;
	CComboBox	m_cbWell;
	CButton	m_btnTestBd;
	CButton	m_btnStore;
	CButton	m_btnGetData;
	CButton	m_btnBalance;
	BOOL	m_bTECooler;
	long	m_lIntTime;
	long	m_lTimeAve;
	CString	m_strIntTime;
	CString	m_strStatus;
	CString	m_strTECooler;
	CString	m_strTestBd;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSDK_SM301Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	long m_lPxlNum;	// Detector Pixel number
	long m_lWell;	// Charge Well Size Index (0:1pF, 1:4pF, 2:7pF, 3:10pF)
	long m_lArrayMode;	// Array mode. (0: Mux order => Sens Array detector, 1: Array order => Cal Sensor detector)
	bool m_bIsConnected;	// Is the detector board connected?
	void DisableCtrls();
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSDK_SM301Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBtnTestBoard();
	afx_msg void OnClose();
	virtual void OnCancel();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnCheckTECoolerOn();
	afx_msg void OnChangeEditIntTime();
	afx_msg void OnSelchangeComboWell();
	afx_msg void OnBtnBalance();
	afx_msg void OnBtnGetData();
	afx_msg void OnBtnStore();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SDK_SM301DLG_H__7E2FDAE4_19B8_4DA9_B4C6_0B20AE981294__INCLUDED_)
